#include "nt.h"
#include "txtstr.h"

void NameDef::allocateArray(int n) {
    assert(n > 0);
    if (n <= 0)
        n = 1;
    if (baseType == TYPE_INT) {
        array = (void *) new int[n];
    } else if (baseType == TYPE_DOUBLE) {
        array = (void *) new double[n];
    } else if (baseType == TYPE_STRING) {
        array = (void *) new TextString[n];
    } else {
        assert(false);
    }
    dimension = n;
}

NameDef* NameTable::findName(const char *name) const {
    moveToBeg();
    while (pointerNext != 0) {
        if (strcmp(name, ((NameDef*) pointerNext)->name) == 0) {
            return ((NameDef*) pointerNext);
        }
        moveForward();
    }
    return 0;
}

NameDef* NameTable::addName(const char *name) {
    NameDef *n = findName(name);
    if (n != 0)
        return n;
    n = new NameDef(name);
    moveToBeg();
    insertBefore(n);
    return n;
}
