#ifndef SCANNER_H
#define SCANNER_H

#define NAMEMAX 255
#define STRMAX  1023

#include "tree.h"
#include "nametab.h"

typedef struct {
    int int_value;
    char text_value[NAMEMAX+1];
    tree_ptr t;
    name_ptr name;
    int int_value2;
    void *ptr_value;
    void *ptr_value2;
} yys;

#define YYSTYPE yys

#include "comp.tab.h"

extern FILE *yyin;
int yylex();
extern YYSTYPE yylval;
extern char strbuf[STRMAX+1];
extern int yylineno;            /* Line number maintained by FLEX */

/* Lexeme values that are not lexems */

#define EQ      32
#define NE      33
#define LT      34
#define LE      35
#define GT      36
#define GE      37

#define DIV     38
#define MOD     39
#define LS      40
#define RS      41
#define ICR     42
#define DECR    43
#define INT     44
#define CHAR    45
#define VOID    46

/* Unsigned comparings */
#define LTU     47
#define LEU     48
#define GTU     49
#define GEU     50

#endif
